Page MenuHomeFreeBSD

ix(4): Run {mod,msf,mbx,fdir,phy}_task in if_update_admin_status
ClosedPublic

Authored by piotr.pietruszewski_intel.com on Dec 7 2018, 12:52 PM.

Details

Summary

This patch introduces adapter->task_requests register responsible for
recording requests for mod_task, msf_task, mbx_task, fdir_task and
phy_task calls. Instead of enqueueing these tasks with
GROUPTASK_ENQUEUE, handlers will be called directly from
ixgbe_if_update_admin_status() while holding ctx lock.

SIOCGIFXMEDIA ioctl() call reads adapter->media list. The list is
deleted and rewritten in ixgbe_handle_msf() task without holding ctx
lock. This change is needed to maintain data coherency when sharing
adapter info via ioctl() calls.

Patch co-authored by Krzysztof Galazka <krzysztof.galazka@intel.com>.

Diff Detail

Repository
rS FreeBSD src repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

pi added a subscriber: pi.Dec 7 2018, 1:20 PM
sbruno accepted this revision.Dec 10 2018, 4:03 PM
This revision is now accepted and ready to land.Dec 10 2018, 4:03 PM
This revision now requires review to proceed.Dec 11 2018, 2:00 PM
This revision is now accepted and ready to land.Jan 31 2019, 4:17 PM
This revision was automatically updated to reflect the committed changes.